Index: palm/trunk/SOURCE/pres.f90
===================================================================
--- palm/trunk/SOURCE/pres.f90	(revision 4901)
+++ palm/trunk/SOURCE/pres.f90	(revision 1)
@@ -1,65 +1,99 @@
-!> @file pres.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-!
-! Current revisions:
+ SUBROUTINE pres
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
 ! -----------------
-!
+! 
 !
 ! Former revisions:
 ! -----------------
-! $Id$
-! bugfix: mean w removal not applied to ghost points of the total domain in case of non-cyclic
-! setups
-!
-! 4828 2021-01-05 11:21:41Z Giersch
-! Bugfix in OpenMP directives - intel compiler do not allow reduction operations on array elements
-!
-! 4719 2020-10-01 11:28:33Z pavelkrc
-! Bugfix of previous commit (div_old discrepancy)
-!
-! 4717 2020-09-30 22:27:40Z pavelkrc
-! Fixes and optimizations of OpenMP parallelization, formatting of OpenMP
-! directives (J. Resler)
-!
-! 4651 2020-08-27 07:17:45Z raasch
-! preprocessor branch for ibm removed
-!
-! 4649 2020-08-25 12:11:17Z raasch
-! File re-formatted to follow the PALM coding standard
-!
-! 4457 2020-03-11 14:20:43Z raasch
-! use statement for exchange horiz added
-!
-! 4360 2020-01-07 11:25:50Z suehring
-! Introduction of wall_flags_total_0, which currently sets bits based on static
-! topography information used in wall_flags_static_0
-!
-! 4329 2019-12-10 15:46:36Z motisi
-! Renamed wall_flags_0 to wall_flags_static_0
-!
-! 4182 2019-08-22 15:20:23Z scharf
-! Corrected "Former revisions" section
-!
-! 4015 2019-06-05 13:25:35Z raasch
-! variable child_domain_nvn eliminated
-!
-! 3849 2019-04-01 16:35:16Z knoop
-! OpenACC port for SPEC
+! $Log: pres.f90,v $
+! Revision 1.25  2006/04/26 13:26:12  raasch
+! OpenMP optimization (+localsum, threadsum)
+!
+! Revision 1.24  2006/02/23 12:50:08  raasch
+! nzb replaced by nzb_.._inner, optional volume flow control, calculation of
+! divergence sum reordered due to optimization
+!
+! Revision 1.23  2005/05/18 15:53:44  raasch
+! call conditions for poisfft_hybrid modified
+!
+! Revision 1.22  2005/03/26 20:57:24  raasch
+! Adjustments for non-cyclic boundary conditions: arguments added to routine
+! exchange_horiz, mean horizontal wind parallel to the outflow is calculated.
+!
+! Revision 1.21  2004/04/30 12:45:00  raasch
+! Most of the arguments removed from poisfft call, +module poisfft_mod,
+! poisfft is also used for 1d-decompositions, more memory has to be
+! allocated for tend, when an enlarged domain is used for transposition
+!
+! Revision 1.20  2003/03/16 09:46:02  raasch
+! Two underscores (_) are placed in front of all define-strings
+!
+! Revision 1.19  2003/03/14 13:46:32  raasch
+! Optimization of loops (IBM-version and vectorizable version)
+!
+! Revision 1.18  2003/03/12 16:38:20  raasch
+! Simulated_time has been replaced by sums(nzb+1,4) in first if clause
+! in order to avoid run time errors due to compiler bugs on ibm and nec
+! machines, due to optimization, dividing d by dt_3d is now done in the
+! first loop (not in a seperated loop),
+! error removed: tend=p added after calling sor method
+!
+! Revision 1.17  2002/06/11 13:17:03  raasch
+! Hybrid solver included, array operations on d removed due to bad performance
+! on IBM, loops including the array d are combined, OpenMP directives added.
+! Total perturbation pressure is no more obtained iteratively (p=p+tend) from
+! the current perturbation pressure.
+!
+! Revision 1.16  2001/09/04  12:05:52  12:05:52  raasch (Siegfried Raasch)
+! Value of perturbation pressure is no more obtained iteratively (p = p + tend,
+! FFT-solver only)
+! 
+! Revision 1.15  2001/07/20 13:12:54  raasch
+! Multigrid method included
+!
+! Revision 1.14  2001/03/30 07:47:29  raasch
+! All arguments removed, dp replaced by tend, array work removed from
+! sor argument list,
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.13  2001/01/22 07:53:53  raasch
+! Module test_variables removed
+!
+! Revision 1.12  2000/01/26 13:23:32  letzel
+! All comments translated into English
+!
+! Revision 1.11  1998/09/22 17:28:14  raasch
+! dp war bei SOR-Aufrufen bisher nicht initialisiert, entsprechend geaendert
+!
+! Revision 1.10  1998/07/06 12:30:22  raasch
+! + USE test_variables
+!
+! Revision 1.9  1998/04/15 11:23:20  raasch
+! Testweise Zusatzbedingung fuer den Druck am unteren Rand bei inhomogener
+! Oberflaechentemperatur (pt wird uebergeben)
+!
+! Revision 1.8  1998/03/30 11:37:59  raasch
+! Divergenzsummenberechnung (PEs) nach flow_statistics verlagert
+!
+! Revision 1.7  1998/03/25 13:56:16  raasch
+! dt in dt_3d umbenannt
+!
+! Revision 1.6  1997/09/16 06:38:37  raasch
+! Ueberfluessige Initialisierung von d entfernt
+!
+! Revision 1.5  1997/09/12 06:29:56  raasch
+! Randbedingungen umbenannt
+!
+! Revision 1.4  1997/09/09 08:30:27  raasch
+! Kehrwerte der Gitterweiten implementiert
+!
+! Revision 1.3  1997/08/26 06:34:16  raasch
+! Gesamtstoerdruck p wird in Bew.gleichungen mitgerechnet und ergibt sich
+! durch Summation des aktuellen Stoerdrucks dp, mit dem hier korrigiert wird
+!
+! Revision 1.2  1997/08/11 06:25:24  raasch
+! Felder werden ueber Formalparameterliste uebergeben.
 !
 ! Revision 1.1  1997/07/24 11:24:44  raasch
@@ -67,130 +101,30 @@
 !
 !
-!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Compute the divergence of the provisional velocity field. Solve the Poisson equation for the
-!> perturbation pressure. Compute the final velocities using this perturbation pressure. Compute the
-!> remaining divergence.
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE pres
-
-
-    USE arrays_3d,                                                                                 &
-        ONLY:  d,                                                                                  &
-               ddzu,                                                                               &
-               ddzu_pres,                                                                          &
-               ddzw,                                                                               &
-               dzw,                                                                                &
-               p,                                                                                  &
-               p_loc,                                                                              &
-               rho_air,                                                                            &
-               rho_air_zw,                                                                         &
-               tend,                                                                               &
-               u,                                                                                  &
-               v,                                                                                  &
-               w
-
-    USE control_parameters,                                                                        &
-        ONLY:  bc_lr_cyc,                                                                          &
-               bc_ns_cyc,                                                                          &
-               bc_radiation_l,                                                                     &
-               bc_radiation_n,                                                                     &
-               bc_radiation_r,                                                                     &
-               bc_radiation_s,                                                                     &
-               child_domain,                                                                       &
-               conserve_volume_flow,                                                               &
-               coupling_mode,                                                                      &
-               dt_3d,                                                                              &
-               gathered_size,                                                                      &
-               ibc_p_b,                                                                            &
-               ibc_p_t,                                                                            &
-               intermediate_timestep_count,                                                        &
-               intermediate_timestep_count_max,                                                    &
-               mg_switch_to_pe0_level,                                                             &
-               nesting_offline,                                                                    &
-               psolver,                                                                            &
-               subdomain_size,                                                                     &
-               topography,                                                                         &
-               volume_flow,                                                                        &
-               volume_flow_area,                                                                   &
-               volume_flow_initial
-
-    USE cpulog,                                                                                    &
-        ONLY:  cpu_log,                                                                            &
-               log_point,                                                                          &
-               log_point_s
-
-    USE exchange_horiz_mod,                                                                        &
-        ONLY:  exchange_horiz
-
-    USE grid_variables,                                                                            &
-        ONLY:  ddx,                                                                                &
-               ddy
-
-    USE indices,                                                                                   &
-        ONLY:  nbgp,                                                                               &
-               ngp_2dh_outer,                                                                      &
-               nx,                                                                                 &
-               nxl,                                                                                &
-               nxlg,                                                                               &
-               nxl_mg,                                                                             &
-               nxr,                                                                                &
-               nxrg,                                                                               &
-               nxr_mg,                                                                             &
-               ny,                                                                                 &
-               nys,                                                                                &
-               nysg,                                                                               &
-               nys_mg,                                                                             &
-               nyn,                                                                                &
-               nyng,                                                                               &
-               nyn_mg,                                                                             &
-               nzb,                                                                                &
-               nzt,                                                                                &
-               nzt_mg,                                                                             &
-               wall_flags_total_0
-
-    USE kinds
-
+! Compute the divergence of the provisional velocity field. Solve the Poisson
+! equation for the perturbation pressure. Compute the final velocities using
+! this perturbation pressure. Compute the remaining divergence.
+!------------------------------------------------------------------------------!
+
+    USE arrays_3d
+    USE constants
+    USE control_parameters
+    USE cpulog
+    USE grid_variables
+    USE indices
+    USE interfaces
     USE pegrid
-
-    USE pmc_interface,                                                                             &
-        ONLY:  nesting_mode
-
-    USE poisfft_mod,                                                                               &
-        ONLY:  poisfft
-
-    USE poismg_mod
-
-    USE poismg_noopt_mod
-
-    USE statistics,                                                                                &
-        ONLY:  statistic_regions,                                                                  &
-               sums_divnew_l,                                                                      &
-               sums_divold_l,                                                                      &
-               weight_pres,                                                                        &
-               weight_substep
-
-    USE surface_mod,                                                                               &
-        ONLY :  bc_h
+    USE poisfft_mod
+    USE poisfft_hybrid_mod
+    USE statistics
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i  !<
-    INTEGER(iwp) ::  j  !<
-    INTEGER(iwp) ::  k  !<
-    INTEGER(iwp) ::  m  !<
-
-    REAL(wp) ::  ddt_3d            !<
-    REAL(wp) ::  d_weight_pres     !<
-    REAL(wp) ::  localsum          !<
-    REAL(wp) ::  threadsum         !<
-    REAL(wp) ::  weight_pres_l     !<
-    REAL(wp) ::  weight_substep_l  !<
-
-    REAL(wp), DIMENSION(1:3)   ::  volume_flow_l       !<
-    REAL(wp), DIMENSION(1:3)   ::  volume_flow_offset  !<
-    REAL(wp), DIMENSION(1:nzt) ::  w_l                 !<
-    REAL(wp), DIMENSION(1:nzt) ::  w_l_l               !<
+    INTEGER ::  i, j, k, sr
+
+    REAL    ::  localsum, threadsum
+
+    REAL, DIMENSION(1:2) ::  volume_flow_l, volume_flow_offset
 
 
@@ -198,181 +132,8 @@
 
 !
-!-- Calculate quantities to be used locally
-    ddt_3d = 1.0_wp / dt_3d
-    IF ( intermediate_timestep_count == 0 )  THEN
-!
-!--    If pres is called before initial time step
-       weight_pres_l    = 1.0_wp
-       d_weight_pres    = 1.0_wp
-       weight_substep_l = 1.0_wp
-    ELSE
-       weight_pres_l    = weight_pres(intermediate_timestep_count)
-       d_weight_pres    = 1.0_wp / weight_pres(intermediate_timestep_count)
-       weight_substep_l = weight_substep(intermediate_timestep_count)
-    ENDIF
-
-!
-!-- Multigrid method expects array d to have one ghost layer.
-!--
-    IF ( psolver(1:9) == 'multigrid' )  THEN
-
+!-- Multigrid method needs additional grid points for the divergence array
+    IF ( psolver == 'multigrid' )  THEN
        DEALLOCATE( d )
        ALLOCATE( d(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
-
-!
-!--    Since p is later used to hold the weighted average of the substeps, it cannot be used in the
-!--    iterative solver. Therefore, its initial value is stored on p_loc, which is then iteratively
-!--    advanced in every substep.
-       IF ( intermediate_timestep_count <= 1 )  THEN
-          DO  i = nxl-1, nxr+1
-             DO  j = nys-1, nyn+1
-                DO  k = nzb, nzt+1
-                   p_loc(k,j,i) = p(k,j,i)
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-
-    ELSEIF ( psolver == 'sor'  .AND.  intermediate_timestep_count <= 1 )  THEN
-
-!
-!--    Since p is later used to hold the weighted average of the substeps, it cannot be used in the
-!--    iterative solver. Therefore, its initial value is stored on p_loc, which is then iteratively
-!--    advanced in every substep.
-       p_loc = p
-
-    ENDIF
-
-!
-!-- Conserve the volume flow at the outflow in case of non-cyclic lateral boundary conditions
-!-- WARNING: so far, this conservation does not work at the left/south boundary if the topography at
-!--          the inflow differs from that at the outflow! For this case, volume_flow_area needs
-!--          adjustment!
-!
-!-- Left/right
-    IF ( conserve_volume_flow  .AND.  ( bc_radiation_l .OR. bc_radiation_r ) )  THEN
-
-       volume_flow(1)   = 0.0_wp
-       volume_flow_l(1) = 0.0_wp
-
-       IF ( bc_radiation_l )  THEN
-          i = 0
-       ELSEIF ( bc_radiation_r )  THEN
-          i = nx+1
-       ENDIF
-
-       DO  j = nys, nyn
-!
-!--       Sum up the volume flow through the south/north boundary
-          DO  k = nzb+1, nzt
-             volume_flow_l(1) = volume_flow_l(1) + u(k,j,i) * dzw(k)                               &
-                                * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 1 ) )
-          ENDDO
-       ENDDO
-
-#if defined( __parallel )
-       IF ( collective_wait )  CALL MPI_BARRIER( comm1dy, ierr )
-       CALL MPI_ALLREDUCE( volume_flow_l(1), volume_flow(1), 1, MPI_REAL, MPI_SUM, comm1dy, ierr )
-#else
-       volume_flow = volume_flow_l
-#endif
-       volume_flow_offset(1) = ( volume_flow_initial(1) - volume_flow(1) ) / volume_flow_area(1)
-
-       DO  j = nysg, nyng
-          DO  k = nzb+1, nzt
-             u(k,j,i) = u(k,j,i) + volume_flow_offset(1)                                           &
-                        * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 1 ) )
-          ENDDO
-       ENDDO
-
-    ENDIF
-
-!
-!-- South/north
-    IF ( conserve_volume_flow  .AND.  ( bc_radiation_n .OR. bc_radiation_s ) )  THEN
-
-       volume_flow(2)   = 0.0_wp
-       volume_flow_l(2) = 0.0_wp
-
-       IF ( bc_radiation_s )  THEN
-          j = 0
-       ELSEIF ( bc_radiation_n )  THEN
-          j = ny+1
-       ENDIF
-
-       DO  i = nxl, nxr
-!
-!--       Sum up the volume flow through the south/north boundary
-          DO  k = nzb+1, nzt
-             volume_flow_l(2) = volume_flow_l(2) + v(k,j,i) * dzw(k)                               &
-                                * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 2 ) )
-          ENDDO
-       ENDDO
-
-#if defined( __parallel )
-       IF ( collective_wait )  CALL MPI_BARRIER( comm1dx, ierr )
-       CALL MPI_ALLREDUCE( volume_flow_l(2), volume_flow(2), 1, MPI_REAL, MPI_SUM, comm1dx, ierr )
-#else
-       volume_flow = volume_flow_l
-#endif
-       volume_flow_offset(2) = ( volume_flow_initial(2) - volume_flow(2) ) / volume_flow_area(2)
-
-       DO  i = nxlg, nxrg
-          DO  k = nzb+1, nzt
-             v(k,j,i) = v(k,j,i) + volume_flow_offset(2)                                           &
-                        * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 2 ) )
-          ENDDO
-       ENDDO
-
-    ENDIF
-
-!
-!-- Remove mean vertical velocity in case that Neumann conditions are used both at bottom and top
-!-- boundary. With Neumann conditions at both vertical boundaries, the solver cannot remove mean
-!-- vertical velocities. They should be removed, because incompressibility requires that the
-!-- vertical gradient of vertical velocity is zero. Since w=0 at the solid surface, it must be zero
-!-- everywhere.
-!-- This must not be done in case of a 3d-nesting child domain, because a mean vertical velocity
-!-- can physically exist in such a domain.
-!-- Also in case of offline nesting, mean vertical velocities may exist (and must not be removed),
-!-- caused by horizontal divergence/convergence of the large scale flow that is prescribed at the
-!-- side boundaries.
-!-- The removal cannot be done before the first initial time step because ngp_2dh_outer is not yet
-!-- known then.
-    IF ( ibc_p_b == 1  .AND.  ibc_p_t == 1  .AND.  .NOT. nesting_offline                           &
-         .AND. .NOT. ( child_domain .AND. nesting_mode /= 'vertical' )                             &
-         .AND. intermediate_timestep_count /= 0 )  THEN
-       w_l = 0.0_wp;  w_l_l = 0.0_wp
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = nzb+1, nzt
-                w_l_l(k) = w_l_l(k) + w(k,j,i)                                                     &
-                           * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 3 ) )
-             ENDDO
-          ENDDO
-       ENDDO
-#if defined( __parallel )
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( w_l_l(1), w_l(1), nzt, MPI_REAL, MPI_SUM, comm2d, ierr )
-#else
-       w_l = w_l_l
-#endif
-       DO  k = 1, nzt
-          w_l(k) = w_l(k) / ngp_2dh_outer(k,0)
-       ENDDO
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = nzb+1, nzt
-                w(k,j,i) = w(k,j,i) - w_l(k)                                                       &
-                           * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 3 ) )
-             ENDDO
-          ENDDO
-       ENDDO
-!
-!--    Instead of running the above loop over ghost points, they are set via exchange_horiz,
-!--    in order to correctly consider non-cyclic boundary conditions, where ghost boundaries
-!--    of the total domain must not be set. Otherwise w may continuously increase/decrease
-!--    at these points.
-       CALL exchange_horiz( w, nbgp )
     ENDIF
 
@@ -381,74 +142,155 @@
     CALL cpu_log( log_point_s(1), 'divergence', 'start' )
 
-    IF ( psolver(1:9) == 'multigrid' )  THEN
-       !$OMP PARALLEL DO PRIVATE (i,j,k) SCHEDULE( STATIC )
+    IF ( psolver == 'multigrid' )  THEN
+       !$OMP PARALLEL DO SCHEDULE( STATIC )
        DO  i = nxl-1, nxr+1
           DO  j = nys-1, nyn+1
              DO  k = nzb, nzt+1
-                d(k,j,i) = 0.0_wp
+                d(k,j,i) = 0.0
              ENDDO
           ENDDO
        ENDDO
     ELSE
-       !$OMP PARALLEL DO PRIVATE (i,j,k) SCHEDULE( STATIC )
-       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
-       !$ACC PRESENT(d)
+       !$OMP PARALLEL DO SCHEDULE( STATIC )
+       DO  i = nxl, nxra
+          DO  j = nys, nyna
+             DO  k = nzb+1, nzta
+                d(k,j,i) = 0.0
+             ENDDO
+          ENDDO
+       ENDDO
+    ENDIF
+
+    localsum  = 0.0
+    threadsum = 0.0
+
+#if defined( __ibm )
+    !$OMP PARALLEL PRIVATE (i,j,k) FIRSTPRIVATE(threadsum) REDUCTION(+:localsum)
+    !$OMP DO SCHEDULE( STATIC )
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          DO  k = nzb_s_inner(j,i)+1, nzt
+             d(k,j,i) = ( u(k,j,i+1) - u(k,j,i) ) * ddx + &
+                        ( v(k,j+1,i) - v(k,j,i) ) * ddy + &
+                        ( w(k,j,i) - w(k-1,j,i) ) * ddzw(k)
+          ENDDO
+!
+!--       Additional pressure boundary condition at the bottom boundary for 
+!--       inhomogeneous Prandtl layer heat fluxes and temperatures, respectively
+!--       dp/dz = -(dtau13/dx + dtau23/dy) + g*pt'/pt0.
+!--       This condition must not be applied at the start of a run, because then
+!--       flow_statistics has not yet been called and thus sums = 0.
+          IF ( ibc_p_b == 2  .AND.  sums(nzb+1,4) /= 0.0 )  THEN
+             k = nzb_s_inner(j,i)
+             d(k+1,j,i) = d(k+1,j,i) + (                                     &
+                                         ( usws(j,i+1) - usws(j,i) ) * ddx   &
+                                       + ( vsws(j+1,i) - vsws(j,i) ) * ddy   &
+                                       - g * ( pt(k+1,j,i) - sums(k+1,4) ) / &
+                                         sums(k+1,4)                         &
+                                       ) * ddzw(k+1)
+          ENDIF
+
+!
+!--       Compute possible PE-sum of divergences for flow_statistics
+          DO  k = nzb_s_inner(j,i)+1, nzt
+             threadsum = threadsum + ABS( d(k,j,i) )
+          ENDDO
+
+!
+!--       Velocity corrections are made with Euler step size. Right hand side
+!--       of Poisson equation has to be set appropriately
+          DO  k = nzb_s_inner(j,i)+1, nzt
+             d(k,j,i) = d(k,j,i) / dt_3d
+          ENDDO
+
+       ENDDO
+    ENDDO
+
+    localsum = localsum + threadsum
+    !$OMP END PARALLEL
+#else
+    IF ( ibc_p_b == 2 .AND. sums(nzb+1,4) /= 0.0 )  THEN
+       !$OMP PARALLEL PRIVATE (i,j,k)
+       !$OMP DO SCHEDULE( STATIC )
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb+1, nzt
-                d(k,j,i) = 0.0_wp
-             ENDDO
-          ENDDO
-       ENDDO
+             DO  k = nzb_s_inner(j,i)+1, nzt
+                d(k,j,i) = ( u(k,j,i+1) - u(k,j,i) ) * ddx + &
+                           ( v(k,j+1,i) - v(k,j,i) ) * ddy + &
+                           ( w(k,j,i) - w(k-1,j,i) ) * ddzw(k)
+             ENDDO
+          ENDDO
+!
+!--       Additional pressure boundary condition at the bottom boundary for
+!--       inhomogeneous Prandtl layer heat fluxes and temperatures, respectively
+!--       dp/dz = -(dtau13/dx + dtau23/dy) + g*pt'/pt0.
+!--       This condition must not be applied at the start of a run, because then
+!--       flow_statistics has not yet been called and thus sums = 0.
+          DO  j = nys, nyn
+              k = nzb_s_inner(j,i)
+              d(k+1,j,i) = d(k+1,j,i) + (                        &
+                             ( usws(j,i+1) - usws(j,i) ) * ddx   &
+                           + ( vsws(j+1,i) - vsws(j,i) ) * ddy   &
+                           - g * ( pt(k+1,j,i) - sums(k+1,4) ) / &
+                             sums(k+1,4)                         &
+                                        ) * ddzw(k+1)
+          ENDDO
+       ENDDO
+       !$OMP END PARALLEL
+
+    ELSE
+
+       !$OMP PARALLEL PRIVATE (i,j,k)
+       !$OMP DO SCHEDULE( STATIC )
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb_s_inner(j,i)+1, nzt
+                d(k,j,i) = ( u(k,j,i+1) - u(k,j,i) ) * ddx + &
+                           ( v(k,j+1,i) - v(k,j,i) ) * ddy + &
+                           ( w(k,j,i) - w(k-1,j,i) ) * ddzw(k)
+             ENDDO
+          ENDDO
+       ENDDO
+       !$OMP END PARALLEL
+
     ENDIF
 
-    localsum  = 0.0_wp
-    threadsum = 0.0_wp
-
-    !$OMP PARALLEL PRIVATE (i,j,k)
+!
+!-- Compute possible PE-sum of divergences for flow_statistics
+    !$OMP PARALLEL PRIVATE (i,j,k) FIRSTPRIVATE(threadsum) REDUCTION(+:localsum)
     !$OMP DO SCHEDULE( STATIC )
-    !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
-    !$ACC PRESENT(u, v, w, rho_air, rho_air_zw, ddzw, wall_flags_total_0) &
-    !$ACC PRESENT(d)
     DO  i = nxl, nxr
        DO  j = nys, nyn
-          DO  k = 1, nzt
-             d(k,j,i) = ( ( u(k,j,i+1) - u(k,j,i) ) * rho_air(k) * ddx +                           &
-                          ( v(k,j+1,i) - v(k,j,i) ) * rho_air(k) * ddy +                           &
-                          ( w(k,j,i)   * rho_air_zw(k) - w(k-1,j,i) * rho_air_zw(k-1) )            &
-                          * ddzw(k) ) * ddt_3d * d_weight_pres                                     &
-                        * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
+          DO  k = nzb+1, nzt
+             threadsum = threadsum + ABS( d(k,j,i) )
           ENDDO
        ENDDO
     ENDDO
+    localsum = localsum + threadsum
     !$OMP END PARALLEL
 
 !
-!-- Compute possible PE-sum of divergences for flow_statistics. Carry out computation only at last
-!-- Runge-Kutta substep.
-    IF ( intermediate_timestep_count == intermediate_timestep_count_max  .OR.                      &
-         intermediate_timestep_count == 0 )  THEN
-       !$OMP PARALLEL PRIVATE (i,j,k) FIRSTPRIVATE(threadsum) REDUCTION(+:localsum)
-       !$OMP DO SCHEDULE( STATIC )
-       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
-       !$ACC REDUCTION(+:threadsum) COPY(threadsum) &
-       !$ACC PRESENT(d)
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = nzb+1, nzt
-                threadsum = threadsum + ABS( d(k,j,i) )
-             ENDDO
-          ENDDO
-       ENDDO
-       localsum = localsum + threadsum * dt_3d * weight_pres_l
-       !$OMP END PARALLEL
-    ENDIF
-
-!
-!-- For completeness, set the divergence sum of all statistic regions to those of the total domain
-    IF ( intermediate_timestep_count == intermediate_timestep_count_max  .OR.                      &
-         intermediate_timestep_count == 0 )  THEN
-       sums_divold_l(0:statistic_regions) = localsum
-    ENDIF
+!-- Velocity corrections are made with Euler step size. Right hand side
+!-- of Poisson equation has to be set appropriately
+    !$OMP DO SCHEDULE( STATIC )
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          DO  k = nzb_s_inner(j,i)+1, nzt
+             d(k,j,i) = d(k,j,i) / dt_3d
+          ENDDO
+       ENDDO
+    ENDDO
+#endif
+
+!
+!-- For completeness, set the divergence sum of all statistic regions to those
+!-- of the total domain
+    sums_divold_l(0:statistic_regions) = localsum
+
+!
+!-- Determine absolute minimum/maximum (only for test cases, therefore as
+!-- comment line)
+!    CALL global_min_max( nzb+1, nzt, nys, nyn, nxl, nxr, d, 'abs', divmax, &
+!                         divmax_ijk )
 
     CALL cpu_log( log_point_s(1), 'divergence', 'stop' )
